Shortest Path with Obstacle( CodeForces - 1547A )(模拟)

简介: Shortest Path with Obstacle( CodeForces - 1547A )(模拟)

There are three cells on an infinite 2-dimensional grid, labeled  A,  B, and  F. Find the length of the shortest path from  A to BB if:


  • in one move you can go to any of the four adjacent cells sharing a side;
  • visiting the cell  F is forbidden (it is an obstacle).


Input


The first line contains an integer t (1≤t≤10^4 ) — the number of test cases in the input. Then  t test cases follow. Before each test case, there is an empty line.


Each test case contains three lines. The first one contains two integers xA,yA  ( 1≤xA,yA≤1000) — coordinates of the start cell A . The second one contains two integers  xB,yB ( 1≤xB,yB≤1000) — coordinates of the finish cell  B. The third one contains two integers xF,yF ( 1≤xF,yF≤1000) — coordinates of the forbidden cell F . All cells are distinct.


Coordinate x corresponds to the column number and coordinate y  corresponds to the row number (see the pictures below).


Output


Output t  lines. The i -th line should contain the answer for the  i-th test case: the length of the shortest path from the cell A  to the cell B  if the cell F is not allowed to be visited.


Example


Input


7


1 1

3 3

2 2


2 5

2 1

2 3


1000 42

1000 1

1000 1000


1 10

3 10

2 10


3 8

7 8

3 7


2 1

4 1

1 1


1 344

1 10

1 1

Output


4

6

41

4

4

2

334


Note


ac287c426dcdadb26a8ca88623ca68f5.png


An example of a possible shortest path for the first test case.


An example of a possible shortest path for the second test case.


题目分析


平面直角坐标系上有两个点和一个障碍。从一个点出发到另一个点,可以走上下左右,不能走障碍,求最短路的长度。


做法



我们发现大部分情况下障碍是不会造成影响的。只有当三个点横坐标相同或者纵坐标相同时且障碍在亮点中间时才会有效。具体实现看代码。


#include<bits/stdc++.h>
using namespace std;
int e[1005][1005];
int main()
{
  int n;
  cin>>n;
  while(n--)
  {
  //  memset(e,0,sizeof(e));
    int x1,y1,x2,y2,a,b;
    cin>>x1>>y1>>x2>>y2>>a>>b;
    if(x1!= x2 && y1 != y2)
    {
      cout<<abs(x1 - x2) + abs(y1 - y2)<<endl;
    }
    else
    {
      if(x1 == x2 && y1 == y2) //|| (x1 == a && y1 == b) || (x2 == a && y2 == b))) 
      {
        cout<<"0"<<endl;
      break;
      }
      if(x1 == x2)
      {
        if(max(y1,y2) > b && min(y1,y2) < b && x1 == a)
        {
          cout<<abs(y1 - y2) + 2<<endl;
        }
        else
        {
          cout<<abs(y1 - y2)<<endl;
        }
      }
      if(y1==y2)
      {
        if(max(x1,x2) > a && min(x1,x2) < a && y1 == b)
        {
          cout<<abs(x1 - x2) + 2<<endl;
        }
        else
        {
          cout<<abs(x1 - x2)<<endl;
        }
      }
    }
  }
  return 0;
}


相关文章
|
Java
hdu1016 Prime Ring Problem【素数环问题(经典dfs)】
hdu1016 Prime Ring Problem【素数环问题(经典dfs)】
47 0
|
文件存储
Easy Number Challenge(埃式筛思想+优雅暴力)
Easy Number Challenge(埃式筛思想+优雅暴力)
83 0
|
C++
【PAT甲级 - C++题解】1046 Shortest Distance
【PAT甲级 - C++题解】1046 Shortest Distance
65 0
[UVA1364 | POJ | NC]Knights of the Round Table | Tarjan 求点双 | 二分图 | 综合图论
我们可以很轻松地发现,被提出的都是在点双连通分量之外的,比如该图中的1 和 5 ,那么怎么判断哪些点不在环中呢? 此时我们还可以逆向思考,不 在 环 中 的 = = 总 的 − 在 环 中 的,所以说现在问题就转换成了满足条件的环内的点的个数
126 0
[UVA1364 | POJ | NC]Knights of the Round Table | Tarjan 求点双 | 二分图 | 综合图论
|
人工智能 BI
[UVA 1599] Ideal Path | 细节最短路
Description New labyrinth attraction is open in New Lostland amusement park. The labyrinth consists of n rooms connected by m passages. Each passage is colored into some color ci .
203 0